VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SOAPCall"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Private sURI As String
Private ogSOAP As ROPE.SOAPPackager
Private oProxy As New ROPE.Proxy

Public Property Let URI(newURI As String)
sURI = newURI

Set ogSOAP = New ROPE.SOAPPackager
If ogSOAP.LoadServicesDescription(icURI, sURI) Then
   oProxy.LoadServicesDescription icSTRING, ogSOAP.ServicesDescription
Else
   Err.Raise 1000, , "Zugriff auf Service fehlgeschlagen"
   Set ogSOAP = Nothing
End If
End Property

Public Property Get URI() As String
URI = sURI
End Property

Public Function IsMethodAvailable(Method As String) As Boolean
IsMethodAvailable = ogSOAP.IsMethodAvailable(Method)
End Function

Public Sub DebugPrintAllMethods()
Dim oMethod As ROPE.SDMethodInfo
Dim oEndpoint As ROPE.SDEndPointInfo
Dim sMethod As String
For Each oMethod In ogSOAP.GetServiceDescriptors(icMETHODINFO)
    sMethod = IIf(oMethod.Type = icFUNCTION, "Function", "Sub")
    sMethod = sMethod & " " & oMethod.Name
    sMethod = sMethod & "(" & GetParameterOrder(oMethod) & ")"
    If oMethod.Type = icFUNCTION Then
        sMethod = sMethod & " As " & VT(oMethod.ReturnType)
    End If
    Debug.Print sMethod
    Debug.Print "Input: " & GetParameterRequest(oMethod)
    Debug.Print "Output: " & GetParameterResponse(oMethod)

    Set oEndpoint = oMethod.SDEndPointInfo
    Debug.Print "Endpoint: " & oEndpoint.URI
    Debug.Print
Next
End Sub

Private Function GetParameterOrder(oMethod As ROPE.SDMethodInfo) As String
Dim oParameter As ROPE.SDParameterInfo
Dim aParameters()
Dim n As Integer
Dim sRet As String

oMethod.CreateParameterArray icPARAMETERORDER, aParameters()
sRet = ""
If oMethod.Type = icMETHOD Or UBound(aParameters, 1) <> 0 Then
   For n = 0 To UBound(aParameters, 1)
      On Error Resume Next: Err = 0
      Set oParameter = aParameters(n)
      If Err = 0 Then
         If oParameter.Direction = icINONLY Then
            sRet = sRet & "byval "
         Else
            sRet = sRet & "byref "
         End If
         sRet = sRet & oParameter.Name
         sRet = sRet & " As " & VT(oParameter.Type) & ", "
      End If
      On Error GoTo 0
   Next n
End If
If Len(sRet) Then
   sRet = Left(sRet, Len(sRet) - 2)
End If
GetParameterOrder = sRet
End Function

Private Function GetParameterResponse(oMethod As ROPE.SDMethodInfo) As String
Dim oParameter As ROPE.SDParameterInfo
Dim aParameters()
Dim n As Integer
Dim sRet As String

oMethod.CreateParameterArray icRESPONSEPARAMETERS, aParameters()
sRet = ""
For n = 0 To UBound(aParameters, 1)
   On Error Resume Next: Err = 0
   Set oParameter = aParameters(n)
   If Err = 0 Then
      sRet = sRet & oParameter.Name & ", "
   End If
   On Error GoTo 0
Next n
If Len(sRet) Then
   sRet = Left(sRet, Len(sRet) - 2)
End If
GetParameterResponse = sRet
End Function

Private Function GetParameterRequest(oMethod As ROPE.SDMethodInfo) As String
Dim oParameter As ROPE.SDParameterInfo
Dim aParameters()
Dim n As Integer
Dim sRet As String

oMethod.CreateParameterArray icREQUESTPARAMETERS, aParameters()
sRet = ""
For n = 0 To UBound(aParameters, 1)
   On Error Resume Next: Err = 0
   Set oParameter = aParameters(n)
   If Err = 0 Then
      sRet = sRet & oParameter.Name & ", "
   End If
   On Error GoTo 0
Next n
If Len(sRet) Then
   sRet = Left(sRet, Len(sRet) - 2)
End If
GetParameterRequest = sRet
End Function

Private Function VT(t As Integer) As String
VT = "<? " & t & " ?>"
If t = icVT_BSTR Then VT = "String"
If t = icVT_I2 Then VT = "Integer"
If t = icVT_I4 Then VT = "Long"
End Function

Public Property Get Proxy() As ROPE.Proxy
Set Proxy = oProxy
End Property
